0.18.00
- First version with HISTORY information.
- Imroved HEX preview in "Checksum research"
- Help menu to Tuner
- Homepage to Help -menu

0.18.01
- Fixed bug: Showing Checksum1 in place of Checksum2

0.18.02
- Fixed bug: If CVN not defined, show nothing, not FFFFFFFF
- Added initial table HEX visualization:
	Table editor -> Graph -> Show table visualization

0.18.03
- Improvements to Table data visualizer

0.18.04
- Speed optimization to Table data visualizer

0.18.05
- Speed optimization to Tuner table preview display
- Speed optimization to XDF export

0.18.06
- Support for address seek to extrainfo
- Support for long searchstring to autodetect

0.18.07
- Load segmentseek-file always when BIN-file file opened

0.18.08
- Support for special chars in Extrainfo

0.18.09
- Fix: filter control characters from extrainfo

0.18.10
- MSB/LSB (Byteswap) support for Tableseek & Segmentseek

0.18.11
- Support for 2 byte addresses in searchstring, Tableseek & Segmentseek

0.18.12
- Fixed MSB/LSB for 2 byte seek

0.18.13
- Fixed MSB/LSB in Tableseek & SegmentSeek (last fix failed)
- Support for platform-specific config-file (example: E38-platform.xml)

0.18.14
- Bugfixes for seek: Multiple extrainfo entries, seek text entries

0.18.15
- Little Endian (LSB) support for BIN-files (need testing)
- File Types handling improved, added default selection

0.18.16
- Small fixes to File Types, BIN (*.bin) added automatically as default to list
 
0.18.17
- Fixed bug in Table data visualizer: Offset not used
- Platform config editor added

0.18.18
- Show offset bytes as green in table data visualizer

0.18.19
- Fixed bug: Offset bytes duplicated in table data visualizer

0.18.20
- Fixed bug: Wrong offset applied to tables in table data visualizer

0.18.21
- Minimal UI fixes

0.18.22
- If no BIN-file loaded, ask what file to load for tableseek & segmentseek
- Save As... to XML editor
- Manual load for platform config file
- Ask filename when saving platform config and no segment config loaded

0.18.23
- Improvements to XML editor, save & close, cancel
- Right click -> "Edit row" to XML editor

0.18.24
- Small UI fix to XML editor
- Fix to Autodetect, file size must be stored as uint, not as hex data. Display hex data when available
- Dtcsearch: support for custom values (Enum:  01:xxx,02:xxx ...)

0.18.25
- Autodetect: Convert all chars to capital before comparing.

0.18.26
- Autodetect new button: read hex data from current bin file

0.18.27
- Checksum research: Print correct number of hex bytes. Swap bytes for current values if selected.
- Autodetect: Add required number of zeros to front of hex value automatically. Set hex textbox red if value too long

0.18.28
- Custom search textbox resizable

0.18.29
- Bosch inv checksum to Checksum Research

0.18.30
- Fixed MSB & Byteswap handling in Checksum Research
- Support for "Bosch Inv" Checksum method to Segment Config
- SegmentConfig Converted Struct -> Class, CSMethod converted const -> enum
- Added "Edit XML" to SegmentConfig
- Added Copy, Paste, Cut to XML Editor

0.18.31
- XML Editor editmode fix, small UI fixes

0.18.32
- Show cheksum byteswapped for LSB files
- Added Cut, Copy, Paste rows to XML Editor

0.18.33
- Fixed Bosch Inv Checksum, 64 bit Chekcsum generated from 2*32bit values in wrong order
- XML Editor "Paste row" is now adding new row instead of replacing current row
- Support for non-linear DTC codes

0.18.34
- DTC Search debugging

0.18.36
- DTC status-string display fixed

0.18.37
- Added Edit Extrainfo -tab for editing EEPROM-data

0.18.38
- New parameter to dtcsearch: CodesPerStatus for binaries where one status is linked to multiple codes
- Fix to "Set DTC" in patcher
- Added "Bosch inv search" to Checksum research (Find possible checksum locations from Bosch file)
 
0.18.39
- Fixed bug: Segment Config not saved when editing in XML Editor
- Swapped DWORDS in Boshc inv checksum for MSB bin
- Support for multiple seek: addresses in Segment PN, Ver etc.

0.18.40
- Fixed bug in pcmfile.parseaddress: if Address not found by seek, return uint.maxvalue, don't continue
- Added Tuner -> Utilities -> Import -> SGM
- File drag & drop support to Patcher & Tuner

0.18.41
- Added Tuner -> Utilities -> Import -> Intel HEX
- Added Tuner -> Utilities -> Import -> Motorola S-Record

0.18.42
- Fixes to Intel & Motorola import

0.18.43
- Use address from S-record/hex-record when writing imported Motorola/intel file
- New dialog: set offset for intel hex/motorola srecord import
- New setting: More settings -> Auto open imported file

0.18.44
- Improved intel hex/motorola import

0.18.45
- Intel/Motorola import: Select segments for import, supply segment filenames
- Fixed bug in XML Editor: Copying multiple rows: modified values reflected to other copies
- Fixed OBD2 Description import, separator can be "," or ";"

0.18.46
- Removed filtering 4xxx, 5xxx and Axxx in DTC search

0.18.47
- Allow modify Data + Gap addresses in Intel/Motorola import, Separate offset removed
- Fixed bug in dtcsearch, only 0-3 or 0-7 (combined) values were allowed in linear mode.

0.18.48
- Fixed bug in Intel/Motorola import, gap calculation off by byte

0.18.49
- Add Offset-gap to beginning of file if in imported file in Intel/Motorola import
- Lot of new XML-files by kur4o

0.18.50
- Block size display and automatic file size calculation to Intel/Motorola import

0.18.51
- Support for secondary DTC codes

0.18.52
- Small bugfix to platform config

0.18.53
- Support for patches in TableData (Patch is like table in tablelist)
- Import patches from XDF as table

0.18.54
- Added "patch" as valuetype to tuner, tree-mode (enum,bitmask,bool,number or patch)

0.18.55
- Support for imperial/metric display units in Tuner. Config in Settings -> More Settings

0.18.56
- Fix sorting in Tuner

0.18.57
- Use Guid instead of id in Tablelists
- Rowheaders can be loaded from table using "guid: <tableguid>". "Table: <TableName>" is still possible, too.

0.18.58
- Fixes to MassModifyTableData
- Speed improvements to Tuner, Table Editor & some other DataGridView controls

0.18.59
- Bug fixes to tuner: Right-click menu broken
- Bug fix: XMLPatch, Table patch compatibility not detected
- Patch selector: Show filename without path, show incompatibility Bold text
- Added compatibility check to Tablelist patches
- Patcher: Refresh "Extra info" comboboxes when opening new file
- Tuner: Column order & size tuning
- Patcher: Don't seek tables or collect other information when fixing multiple files checksums

0.18.60
- Tuner: Fixed bug: "Compare selected tables" not working (Functions in wrong order)
- Tuner: Added Right click menu "Sort by" to tree mode

0.18.61
- Speed improvements to TableEditor (Don't enable radiobuttons after setting every cell value)
- Sort by address added to Tuner, tree mode

0.18.62
- Tuner, fixed bug: Side by side & Side by [side] modes mixed, neither working correctly
- Tuner, fixed bug: Float & Double values not displayed in table description window.
- Tuner, Fix: "Compare selected tables" 

0.18.63
- Table Editor, fixed bug: A<B and A>B show same value
- Table Editor, fixed bugs in multitable view
- Fixed "Find differences (HEX)"

0.18.64
- Table Editor: Show only 4 first chars of guid after tablename, if have duplicate tablenames in multitable
- Table editor: Find tablelist-file from Tuner -folder subfolders, search file with name (in order): <OS>-<Ver>.xml, <OS>.xml, <Platform>-def.xml 
- Upgraded dtcsearch.xml and tableseek-p01-p59.xml

0.18.65
- Tinytuner default location moved to DB folder. If not found, search from startup folder
- stockcvn and referencecvn converted from XML to database
- Added "DB Editor" for cvn editing

0.18.66
- CVN DB: bugfix, xml import put pn to cvn column

0.18.67
- Splash screen showtime as user configurable setting. Default: 4s
- Skip Tuner subfolder if name starts with "."

0.18.68
- Skip Tuner subfolder if name starts with . or ~
- Patcher log & debug font selection added to right-lick menu

0.18.69
- Fixed bug: address definition parsing stopped after one part with "seek:"
- XML editor: Fixed bug: Modifications not always saved

0.18.70
- Fixed bug: address definition with "<number>-seek:" or "seek:-<number>" not parsed correctly
- Fixed bug: Use "compatiblity XML-file" (filename as content of file) only if file exist.

0.18.71
- Fixed bug: address definition with "<number>-seek:" or "seek:-<number>" not parsed correctly 

0.18.72
- Fixed bug: CVN Check failed if no "SegNr" defined

0.18.73
- Fixed bug: Tuner: Not loading files from Tuner -folder, but loading from subfolders

0.18.74
- Bug fixes to XDF import: Don't stop to invalid Category, Remove spaces from start of tablename

0.18.75
- Patcher: Extract segments: Show fileinfo only if checkbox checked, don't seek tables
- Fix for T43 autodetect
- Added "sort files" for sorting large bin file libraries

0.18.76
- Disable sorter in Tourist & Basic mode

0.18.77
- Support for per-table ByteOrder

0.18.78
- Bug fix to TinuTuner DB handling, use subfolder db

0.18.79
- Fixed bug: empty/unknown platform: don't try to open "-platform.xml" (it may exist)
- Tuner: Update left side tree after loading tablelist XML

0.18.80
- MSB/LSB support to xdf export

0.18.81
- XDF export without segment definitions
- New column to TableData: ExtraCategories

0.18.82
- Fixed bug: Tuner: Table preview stop updating in some cases

0.18.83
- XDF Export: Support for linked X/Y axis tables (Requires new xdftable-template)

0.18.84
- XDF import: Support for linked X/Y axis tables, more parameters supported: Units, Min/max..

0.18.85
- Fixed bug in xdftable template: Min/max values exported with extra .0000 
- Tuner: Added new menu entries: Open/Edit axis tables & Math tables
- Fixed bug: Table config not always get saved when modified in editor

0.18.86
- Added setting: More settings -> "XDF import: Link using tablename, not guid"

0.18.87
- Fixed bug in XDF import, Units, min, max missing from constants. 
- Fixed bug in XDF import, Units not always imported for tables

0.18.88
- XDF import: Error handling for extra .0000 in min/max values

0.18.89
- Fixed bug: xdfexport, xdfconstant template min/max value swapped

0.19.00
- Tuner: Support for external flash program
- Tuner: Ask to save modifications before closing
- Patcher: Ask to save modifications before closing
- Function renaming multiple places 
- Cleanup
- Moved common functions to Helpers.cs from PatcherFunctions.cs

0.19.01
- Cleanup

0.19.02
- Fixed bug: Compatibility XML files not loaded
- Tuner: Fixed bug: Saving Tablelist XML even the user click cancel in filename selection

0.19.03
- Bug fix: pidlist.xml in wrong format

0.19.04
- XDF Export: Added units & decimals to constants
- Fixed bug: Pid search using always "diesel" search if search configured in platformconfig
- Bug fix: pidlist.xml in wrong format

0.19.05
- Fixed bug: When opening XML file referenced in another XML, don't assume file is in default XML/Tuner folder, use original file's folder

0.19.06
- Tuner: Fixed bug: Filter by "All" not working
- Fixed bug: Tableseek stop to error "Index was out of range"

0.19.07
- Fixed bug: TableEditor: Paste Special: Negative values not handled correctly (paste fails)
- Added histogram support for existing CSV files

0.19.08
- Histogram: Show tablename
- Histogram: Show selected cell info

0.20.0
- Added basic logging support, currently only standard pids with OBDX Pro supported

0.20.1
- Logger: Initial support for AVT devices

0.20.2
- Logger rewrite, modified copy of PCM Logger

0.20.3
- PCM Hammer included in ZIP package and setup as default Flash application
- Tuner set as default window
- User configurable logger application: internal pcmhammer or external app

0.20.4
- Restored J2534 support to Logger using "J2534DotNet.dll" (Not tested)

0.20.5
- Logger: J2534DotNet.dll removed and functionality added to code
- Logger: More error handling to COM -port functions
- Logger: Added simple PID-parameter editor. No parameter adding or removing yet. Coming later...

0.20.6
- Logger: Revert back from PCM Logger code to own code, using only device code from PCM Logger

0.20.7
- Heavily modified Logger

0.20.8
- Logger: Filtering by OS and testing pids improved.
- Logger: Allow DTC functions during logging
- Logger: VPW Console in settings-tab

0.20.9
- Added Credits to Help-menu
- VPW Console: Added right-click menu (edit, font, save...)
- Analyzer: added Timestamps
- Analyzer: added "Save messages"
- Logger: Use packet arrival timestamp, not log writing time
- Logger: disable wordwrap in console (enable horizontal scrollbar)
- Logger: Timestamps to VPW Console

0.20.10
- Log & Debug display modified to use Events instead of direct write (Thread safe)
- Logger: J2534 device: implemented lock, no concurrent use from different threads
- Logger: Write system time (second resolution) and interface timestamp to logfile. J2534 have internal timestamp, other tools use system timestamps for both
- Logger: Moved Advanced setting & VPW Console to Adnvanced-tab
- Logger: Script upload to VPW Console

0.20.11
- Logger: Better timestamps
- Logger: Upload script: delay between commands, custom delay with row: T:<delay in ms>
- Logger: Concurrent logging & Analyzer possible
- Analyzer: separate start/stop button for analyzer

0.20.12
- Fixes to Logger

0.20.13
- Logger: no automatic connect when enabling VPW console autorefresh
- Logger: fix duplicate rows in VPW Console

0.20.14
- Logger: Improvements to VPW Console, multiple protocols etc.

0.20.15
- Logger: Added J-Console; multi-protocol console for J2534 adapters. 
  Can be used concurrently with serial port adapter (VPW Console, logging, VPW Analyzer)
- Logger: Improvements to script upload.

0.20.16
- Logger: Small fixes, new commands to script

0.20.17
- Logger: fixes to console
- Logger: Added tool for testing seed/key algo
- Logger: Added tool for converting Console log data to bin

0.20.18
- Logger: Fixes to J-Console

0.20.19
- Logger: J-Console: Select log destination: Screen/file
- Tuner: Fix negative offsets in Tableseek ( -D<offset> after searchstring)

0.20.20
- Logger: J-Console: Support for Pass, Block & Flow filters
- Logger: J-Console: Button for filter setup without reconnect

0.20.21
- Tuner: Histogram: Inform user to select table before opening histogram

0.20.22
- Tuner: Added "Execute" for mass modifying table definitions
- Tuner: Added "Extra offset" for testing offset
- Fix: negative offset in table definition
- Tuner: New menu item: Add new table
- Tuner: fixed bug in sort by column

0.20.23
- TableEditor: Offset visualizer: Show table from 2 files side by side
- Segment config: End of segment can be configured as Length: FF-L500, or Length read from bin: FF-L@500
- Tuner: Paste special: remember last settings

0.20.24
- Logger: User selectable timestamp format
- Logger: Automatic reconnect if connection lost
- Offset visualizer & Table data visualizer combined & improved

0.20.25
- Logger: fixed bugs in automatic reconnect

0.20.26
- Offset visualizer: Bug fixes & improvements (Unfinished)
- Included PCM Hammer updated to version 21 
- Logger: User selectable decimal separator
- Logger: AlgoTest: Added "Algo range"

0.20.27
- Logger: Added "Parse CAN logfile to bin"
- Fixed bug in segment handling (crash with empty values)
- MathParser: support for bitwise AND & OR
- DTC Search: support for bitcoded status bytes, added "StatusMath" parameter (For P12 PCM)
- Added support for P10 DTC codes (3 bitcoded tables)
- Tuner: Added support for "virtual DTC table" for P10 DTC

0.21.0
- Logger: Added Graphics

0.21.1
- Logger Graphics: Added Zoom & log window
- Logger Graphics: Support for multichar separators + other bug fixes & improvements

0.21.2
- Logger Graphics: Fixed bug, data points added multiple times while logging
- Logger: Added histogram 

0.21.3
- Logger Graphics: Bug fixes, speed improvements
- Logger: Fixed bug in profile editor => show current value (? -button)

0.21.4
- Logger Graphics: Bug fix: Allow unselect pids
- Logger Graphics: User selectable graph style

0.21.5
- Histogram: support for manual columns & rows
- Logger: Data playback

0.21.6
- Logger graph: Show selected point values in datagridview
- Logger graph: Resample data if zoom level > 2000 pt/screen
- Logger graph: Re-enable zoom with mouse dragging

0.21.7
- Logger graph: Bug fix to "show values with mouse click"
- Logger graph: Added autoscaling
- Logger graph: User selectable mouse function: cursor/zoom
- Logger graph: Bug fixes in timestamp handling
- Logger graph: Move cursor by keyboard. If cursor not in use, move starttime/zoom
- Logger graph: Added playback, lot of internal modifications
- Logger graph: Zoom by mousewheel, hysteresis in zoom by mousedrag, reset zoom with right-click
- Logger graph: Remember mouse settings (zoom, cursor, wheel)
- Logger graph: Skip empty values
- Logger graph: Show selected values as percentage bars

0.21.8
- Dtcsearch: Bug fix to code decoding
- XML files & patches updated, support for new platforms

0.21.9
- TinyTuner: Use hardlimits as Min/max values instead of 0
- TableEditor: Use Min/Max only as warning
- Tuner: Update tablelist automatically after editing table config
- TableEditor: Remember compare selection, if enabled in Settings

0.21.10
- Tuner: Import dtcsearch -tables also in case DTC -tables are imported from TinyTuner DB

0.21.11
- Tuner: Filter tables which differ between files, for example: %difference:A:B
- TableEditor: Don't try to use remembered compare settings, if table missing
- TableEditor: Remember "Show HEX" and "Swap X/Y" settings
- Tuner: Split Categories & Extracategories by " - " to multiple categories
- Tuner: Fixed bugs: select visible columns by right-click in basic-mode
- Tuner: Remember selected tree-node after filtering, or switching between Treemode & Listmode
- Tuner: arrange the categories in alphabetical order
- Tuner: Fixed bug: screen flickering when switching between tables in tree-mode
- Application settings saved to "universalpatcher.xml" in application startupfolder, instead of appdata folder in user profile
- Logger: VPW Console: Selection for logging to File and/or Display

0.21.12
- Tuner: Ask to save modified table, before switching to another table in tree mode
- Tuner: Navigator for opening previously opened node (Right-click to select from list)
- Tuner: In tree mode: Added right click -> Open in list mode
- Tuner: Added "Goto Axis-table" to right-click menu in tree-mode
- Logger: Fixed bug: Math pids not working
- Histogram: Fixed bug: Can't use table without numbers in columnheaders as template
- XML editor: Fixed bugs in row cut/copy/paste. Now using custom list instead of windows clipboard

0.21.13
- Tuner: Navigator assigned to tablelist, if have multiple tablelists/bin-file
- Tuner: Fixes & improvements to navigator
- XML file updates

0.22.00
- Logger: Fixed bug, sent messages not displayed in VPW console unless write to log enabled
- Logger: Fixed bug, crash if select "Filter pids by bin-file" and bin is not supported
- Logger: More device id's added, show ID number with Device name
- Logger: Added DTC -> Query devices
- Logger: Added DTC -> Query modules
- Logger: Added DTC -> Query Freeze frames
- Logger: Device & Function ID/Name moved hardcoded => XML
- Logger: Support for simple variables, for example: $PCM=10 
- Logger: Script: Set expected responses by "defaultresponses:<number>"
- Logger: Fixed bugs in timestamps
- Patcher: New columns and sorting to V6-info
- Patcher: Checksum research: fixed bug: if no Checksum address defined, assumed to be 0 and skipped in calculation
- Logger: Run J2534 in external process to avoid crashes
- XML Editor: "Paste row" allows TableData import to Tableseek list
- Logger: Fixed bug in FTDI detection after plugging in new device ("Unknown: Failure" in device list)
- Logger: Detecting device disconnects and disconnecting automatically (Not with Bluetooth devices)
- Other minor updates & bug fixes

0.22.01
- Tuner: Fixed bug in XDF export
- Logger: J2534 external process handling improved
- Logger: Settings for timeouts

0.22.02
- Logger: Jconsole: Editor for filters, filter redesign
- Segmentseek: Support for big offset
- XML Editor: Fixed bug, Copy/Paste row added reference to copied row, not new object

0.22.03
- Patcher: Added Byteswap: swap all bytes of file
- Logger: OBDScript, support for Programminvoltage (programminvoltage:PIN:Voltage)
- Logger: OBDScript, added wait:message or wait:message:timeout(ms) (example: wait:00 00 05 56 74 99) 
- Logger: OBDScript, added Support for functional addresses (addtofunctmsg:<FuncAddr>, deletefromfunctmsg:<FuncAddr>, clearfunctmsg)
- Logger: OBDScript, added Support for popup. example: popup:Turn ignition ON
- Logger: OBDScript, added Support for eecv & ngc engine seed/key
- Logger: OBDScript, added Support for J2534 Configs, example: setconfigs:DATA_RATE=62500
- Logger: Initial support for JETdevice

0.22.04
- Logger: Jconsole: Add txflags to periodic message. Syntax: <message>:<txflags>
- Logger: OBDScript, added "Startperiodic:<message>:<interval>:<txflags>", "Stopperiodic:<message>:<interval>:<txflags>", "Clearperiodic"
- Logger: OBDScript, added "printall" or "printall:1", "printall:2" to display all received messages from both protocols, or proto 1/2
- Logger: OBDScript: Read response using different protocol than request: <request>:p<responses>, example: 00 00 07 DF 09 02:p1
- Logger: Initial support for CAN protocol in logging

0.22.05
- Logger: Fixed bug: Reconnect using always CAN protocol when VPW selected

0.22.06
- Logger: Added: "Reset connection after missed data:" to avoid connection resets with multiple pids
- Logger: Fixed Misfire Pid descriptions 1200-1208 

0.22.07
- Logger: Fixed bug: Logging failed with ELM device if profile have >38 bytes
- Logger: Profile editor: Added "Filter by OS" and "Filter by query"
- Logger: Reset logger if adding/removing pids while logging
- Logger: Separate timeout settings for J2534 & serialport devices: TimeoutConsoleReceive/TimeoutJConsoleReceive, TimeoutSerialPortWrite/TimeoutJ2534Write
- Logger: CAN protocol imrovements
- Logger: Fix: handle Math pids with divide by zero (Usually when engine not running)
- Logger: OBDScript, support for setconfigs: for Avt device
- Logger: Bug fixes & improvements

0.22.08
- Fixed Bosch Inv checksum
- Logger: OBDScript: Added "disconnect"

0.22.09
- Added missing file: DB\V6CrossRef.mdb
- Logger: Jconsole: Fixed bug, no console output if "Buffered" unchecked
- Logger: OBDScript: Added "connect:<profile>" Example: connect:VPW.xml (Load profile file from script folder or Logger\J2534Profiles\)
- Logger: OBDScript: Added "logger:<data>" To show data in log window. Examples: logger:"Variable1 value=$variable1", "logger:PCM Password: key"

0.22.10
- Logger: Added Action-menu for Clear VPW-Console data & Clear J-Console data
- Logger: Obdscript: Added commands for parsing log to bin file: savebin:<mode>:<filename> or savebin:<mode>:? 
	mode: vpw, can, can36, can23
- Logger: Obdscript: Added command for input variable value: askvariable:variablename:size:hex/int[:comment]
- Logger: Playback logfile: Bug fixes & improvements
- Logger: Playback logfile: Improved timestamp handling (autodetect + manual setting)
- Logger: Graph: Added: Disable resample. + Other improvements

0.22.11
- Logger Graphics: Fixed bug, Bars not updated with live data
- Logger: Added button: "Send Control Command" - Send Control commands to PCM
- Logger: Fixed bug: Bus reset after sending queued command
- Patcher: Fixed bug: DTC tab not updated after modifying DTC

0.22.12
- Tuner: added support for bitmapped tables (1 row = 1 bit)
- Tuner: added more options to "Show as HEX" display
- Tuner: added OS:Address editor

0.22.13
- Patcher: Checksum research: Tab removed, new window with button in "Modify bin" -tab
- Patcher: Checksum research: Big rework, "Unknown range" search with UpTools.DLL (C++)
- Segmentseek: Bug fixes & improvements
- XML files: Lot of updates and support for new bin files

0.22.14
- Patcher: Checksum research: Bugfixes and speed optimization

0.22.15
- Tuner: Added File -> "Create map session" for table mapping
- Tuner: Added Save/load session
- Tuner: Multiple sessions in Tabs. Disabled by default, enable from Settings -> More settings
- Patcher: Checksum research: Allow user add/remove methods + other mods & bugfixes
- Added confirmation for closing Patcher, Tuner or Logger. Disable from Settings -> More settings
- Allow adding new table when tablelist is empty
- Tabledata: New column: OS_Address for OS:Address pairs
- Histogram: Bug fixes, speed improvements

0.22.16
- Histogram: Fixed a bug that prevented the table from being used as a template

0.22.17
- If started without XML folder in place, show warning and exit (Incomplete installation, running directly from ZIP etc.)
- Logger Graphics: Don't use chart internal zooming for X-zoom => Allow deeper zooming
- Logger Graphics: lot of changes
- Histogram: Update parameter lists when pids are added/removed to pid profile in Logger
- Histogram: Fixed bug, Settings -> parameter selection not updated in live logging with Go-button

0.22.18
- Tuner: Table/Offset visualizer updated
- Tuner: Added Smooth-function

0.22.19
- Checksum research: Support for reading range and Checksum address from bin
- Added NGC3 checksum method
- Logger: use always HEX for pin_config
- Logger: Don't use Device timestamps for timestamps with J2534 devices
- J-Console: added IOCTL:function[:argument]
- Added file script_commands.txt, short description of available commands in console

0.22.20
- TableEditor: Fixed bug: In compare mode, up/down table not working
- Logger: Fixed bug in JET device driver, device disconnected in 3 seconds after connection
- XML Editor: Fixed bug: Copy row -> paste row more than once makes "mirrored" copies, not new objects
- Logger: Added parsing for mode 78 logfile to bin
- Upatcher: Moved class initializations to constructor to avoid error in win 7 

0.22.21
- Tuner: Fixed bug: Table editor not updated in tree mode after first table selection

0.22.22
- XML updates

0.22.23
- Logger: Added support for serial port connected wideband O2 sensor
	* add new math value to profile, set address to negative number and use WBAFR or WBRAW as math. Example: (WBRAW / 1000 + 0.5) * 14.7

0.22.24
- Logger: Added support for WBAFR and WBRAW in other pid Math

0.22.25
- Logger: Added support for multiple pids in Math-pid. 
	Example: ([PID1145]/0.2304 + [PID1146]/0.2304 + [PID1148]/0.2304 + [PID1149]/0.2304)/4
	Divide O2 sensors raw values by 0.2304 to get millivolts, and calculate average value
0.22.26
- Logger: Fixed bug: if address is -1, value not displayed. For Math pids -1 is allowed value

0.22.27
- Logger: Support for multiple pids in Math pid when testing pids in profile editor

0.22.28
- Tuner: Show comment about password protected XDF if import fails
- Tuner: Fixed bug: search first exact match of table when selecting table for compare
- Tuner: Fixed bug: V6 compatible OS search failed in some cases
- Autodetect: Better error handling/speed improvement
- Tuner: Bug fixes and speed improvements
- Offset visualizer: Bug fixes & speed improvements
- Swap segments: Cosmetic changes
- Tuner & XML Editor/Configs: Added Undo/Redo
- Logger: Fix to OBDXpro driver, more delay to reset function 
- Tuner: Fixed compatibility problem in XDF export: If tabledescription is over 900 chars long, Tunerpro crash
- Tuner: XDF import bugfixes, Export rewrite: No templates, better support for checksums.
- Logger: Option to disable PID compatibility checking. Workaround for bug: In some cases all pids are incorrectly marked incompatible

0.22.29
- Set Launcher as default window
- Launcher: Added selection "Open in startup"
- Added: File -> "Create debug log..."

0.22.30
- Debug log: add timestamps
- Logger: Request data again, if nothing received in 2 seconds 
- Logger: Added Dashboard (show values in analog gauges)

0.23.00
- Fixed bug: OS not detected if OS is not first segment
- Logger: Profile handling rewrite, other fixes & improvements
- Logger: Start/Stop logging with user-defined key press. Default: F4
- Logger: Added working mode selection
- Logger: Support for DBC files and passive mode logging
- Initial support for running under wine: universalpatcher.sh
- Logger: Support for CAN/ISO15765 protocol with ELM327 fevices
- Logger: Support for TCP/IP server & client for serialport devices
- Logger graphics: Added Color & line width selection

0.23.1
- Logger graphics: Added "Bar all" checkbox
- Logger: small fixes/cleanup

0.23.2
- Logger: Added baudrate 33K3 for CAN protocols
- Logger: Fixed bug in serialport driver; problems with OBDX Pro and other serialport devices
- Logger: Fixed multiple message handling bug in J2534 driver
- Logger: Fixed bug: Protocol selection was available for devices which don't support CAN

0.23.3
- Logger: Added selection for Connectflag
- Logger: Bug fixes for Query CAN devices
- Logger: Bug fixes for ELM327 CAN driver
- Logger: Bug fixes for Serial VB

0.23.4
- Logger: Added Device selection popup (tree)
- Logger: Added support for multiple Connectflags
- Logger: Added more protocols, including ISO15765_FD_PS and CAN_FD_PS
- Tuner: Added interpolation
- Logger: GM "2 byte" key array moved from EXE to XML\2byte-keys.txt
- Logger: Added Customizable Log to Bin converter
- Logger: Show/hide JConsole settings

